/*
 * This file contains single function which estabilishes connection
 * to remote machine.
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include "config.h"

/* returns -- socket if > 0
   can't resolve hostname if = -1
   socket error if 	     = -2
   error during connect      = -3
 */

int make_connection(char *hostname, u_short port)
{
int s;
struct hostent *host_serv;
struct sockaddr_in serv;

	bzero(&serv,sizeof(serv));
	serv.sin_family=AF_INET;
	serv.sin_port  =htons(port);
/*
 * host name may be an IP adderss also
 */
	serv.sin_addr.s_addr = inet_addr(hostname);

/*
 * but if not..
 */
	if (serv.sin_addr.s_addr == INADDR_NONE)
	 {
	  host_serv=gethostbyname(hostname);
	  fflush(stdout);
	  if(host_serv==NULL)
		 return -1; /* can't resolve hostname */
	  bcopy(host_serv->h_addr,&serv.sin_addr,host_serv->h_length);
	 }
	s = socket(AF_INET,SOCK_STREAM,0);
	if ( s < 0 )
		return -2; /* can't create socket */
	if(connect(s,(struct sockaddr *)&serv,sizeof(serv)) < 0 )
			{
			close(s);
			return -3;
			}
	return s;
}
